
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class StudentsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const students = await db.students.create(
            {
                id: data.id || undefined,
        
        nis: data.nis
        ||
        null
            ,
            
        nisn: data.nisn
        ||
        null
            ,
            
        birth_place: data.birth_place
        ||
        null
            ,
            
        birth_date: data.birth_date
        ||
        null
            ,
            
        gender: data.gender
        ||
        null
            ,
            
        address: data.address
        ||
        null
            ,
            
        enrollment_date: data.enrollment_date
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await students.setSchool( data.school || null, {
            transaction,
        });
        
        await students.setUser( data.user || null, {
            transaction,
        });
        
        await students.setCurrent_class( data.current_class || null, {
            transaction,
        });
        

        

        

        return students;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const studentsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                nis: item.nis
            ||
            null
            ,
            
                nisn: item.nisn
            ||
            null
            ,
            
                birth_place: item.birth_place
            ||
            null
            ,
            
                birth_date: item.birth_date
            ||
            null
            ,
            
                gender: item.gender
            ||
            null
            ,
            
                address: item.address
            ||
            null
            ,
            
                enrollment_date: item.enrollment_date
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const students = await db.students.bulkCreate(studentsData, { transaction });

        // For each item created, replace relation files
        

        return students;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const students = await db.students.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.nis !== undefined) updatePayload.nis = data.nis;
        
        
        if (data.nisn !== undefined) updatePayload.nisn = data.nisn;
        
        
        if (data.birth_place !== undefined) updatePayload.birth_place = data.birth_place;
        
        
        if (data.birth_date !== undefined) updatePayload.birth_date = data.birth_date;
        
        
        if (data.gender !== undefined) updatePayload.gender = data.gender;
        
        
        if (data.address !== undefined) updatePayload.address = data.address;
        
        
        if (data.enrollment_date !== undefined) updatePayload.enrollment_date = data.enrollment_date;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        updatePayload.updatedById = currentUser.id;

        await students.update(updatePayload, {transaction});

        
        
        if (data.school !== undefined) {
            await students.setSchool(
              
              data.school,
              
              { transaction }
            );
        }
        
        if (data.user !== undefined) {
            await students.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.current_class !== undefined) {
            await students.setCurrent_class(
              
              data.current_class,
              
              { transaction }
            );
        }
        

        
        

        

        return students;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const students = await db.students.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of students) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of students) {
                await record.destroy({transaction});
            }
        });


        return students;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const students = await db.students.findByPk(id, options);

        await students.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await students.destroy({
            transaction
        });

        return students;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const students = await db.students.findOne(
            { where },
            { transaction },
        );

        if (!students) {
            return students;
        }

        const output = students.get({plain: true});

        
        
        
        
        
        
        
        
        
        output.parent_student_links_student = await students.getParent_student_links_student({
            transaction
        });
        
        
        
        
        
        
        output.attendance_records_student = await students.getAttendance_records_student({
            transaction
        });
        
        
        
        
        output.assignment_submissions_student = await students.getAssignment_submissions_student({
            transaction
        });
        
        
        
        
        
        
        output.exam_attempts_student = await students.getExam_attempts_student({
            transaction
        });
        
        
        
        
        output.billing_items_student = await students.getBilling_items_student({
            transaction
        });
        
        
        
        
        
        output.school = await students.getSchool({
            transaction
        });
        
        
        output.user = await students.getUser({
            transaction
        });
        
        
        output.current_class = await students.getCurrent_class({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userSchools = (user && user.schools?.id) || null;
        

        
        if (userSchools) {
            if (options?.currentUser?.schoolsId) {
                where.schoolsId = options.currentUser.schoolsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.schools,
        as: 'school',
        
      },

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.classes,
        as: 'current_class',
        
        where: filter.current_class ? {
          [Op.or]: [
            { id: { [Op.in]: filter.current_class.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.current_class.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.nis) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'students',
                        'nis',
                        filter.nis,
                    ),
                };
            }
            
            if (filter.nisn) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'students',
                        'nisn',
                        filter.nisn,
                    ),
                };
            }
            
            if (filter.birth_place) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'students',
                        'birth_place',
                        filter.birth_place,
                    ),
                };
            }
            
            if (filter.address) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'students',
                        'address',
                        filter.address,
                    ),
                };
            }
            

            
            

            
            if (filter.birth_dateRange) {
                const [start, end] = filter.birth_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    birth_date: {
                    ...where.birth_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    birth_date: {
                    ...where.birth_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.enrollment_dateRange) {
                const [start, end] = filter.enrollment_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    enrollment_date: {
                    ...where.enrollment_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    enrollment_date: {
                    ...where.enrollment_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.gender) {
                where = {
                    ...where,
                gender: filter.gender,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      
      if (filter.school) {
        const listItems = filter.school.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          schoolId: {[Op.or]: listItems}
        };
      }
      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.schoolsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.students.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'students',
                        'nis',
                        query,
                    ),
                ],
            };
        }

        const records = await db.students.findAll({
            attributes: [ 'id', 'nis' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['nis', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.nis,
        }));
    }

    
};

